#include <pcap.h>
#include <string.h>

#include "host.h"

int get_interface_name(struct host *host)
{
	pcap_if_t *alldevs;
	char errbuf[PCAP_ERRBUF_SIZE];

	if (pcap_findalldevs(&alldevs, errbuf) == -1) {
		dprintf(2, "Error finding devices: %s\n", errbuf);
		return -1;
	}

	for (pcap_if_t *it = alldevs; it != NULL; it = it->next) {
		if (!(it->flags & PCAP_IF_LOOPBACK)) {
			struct sockaddr_in *tmp =
			    (struct sockaddr_in *)it->addresses->addr;
			strcpy(host->interface, it->name);
			strcpy(host->ip, inet_ntoa(tmp->sin_addr));
			pcap_freealldevs(alldevs);
			return 0;
		}
	}

	dprintf(2, "No non-loopback interface found.\n");
	return -1;
}
